/*
 * Alexandre LHUILLIER
 * FIPA 2
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "htmlspitter.h"

void cracherHTML(char* dir, ListeMedias* lm, int nbMedias)
{
    int i = 0, j = 0;
    int nbAuteurs = 0;
    ListeMedias* tmplm = lm;
    ListeAuteurs* tmpla;
    ListeAuteurs** tabAuteurs;
    media** tabMedias = (media**)malloc(nbMedias * sizeof(*tabMedias));
    
    for(i = 0; i < nbMedias; i++)
    {
        tabMedias[i] = tmplm->m;
        tmplm = tmplm->suiv;
        //On vire les blancs au debut des titres pour ne pas fausser les comparaisons
        int j = 0;
        while(tabMedias[i]->titre[j] == ' ' || tabMedias[i]->titre[j] == '\t' || tabMedias[i]->titre[j] == '\n' | tabMedias[i]->titre[j] == '\r')
            tabMedias[i]->titre = &(tabMedias[i]->titre[++j]);
    }
    qsort(tabMedias, nbMedias, sizeof(tabMedias[0]), cmpMedias);
    //ici: on peut ecrire le debut de la page principale
    char* nomFichier = (char*)malloc((strlen(dir)+11)*sizeof(*nomFichier));
    sprintf(nomFichier, "%s/index.html", dir);
    FILE* index = fopen(nomFichier, "w");
    if(index == NULL)
    {
        printf("erreur a l'ouverture du fichier index.html: verifiez que le repertoire %s existe et que vous y avez les permissions d'ecriture\n", dir);
        exit(1);
    }
    printHead("Votre Mediatheque", index);
    fprintf(index, "<h1>Votre Mediatheque</h1><table bgcolor=\"#DDDDAA\">");
    //Ensuite: pour chaque page, trier les noms des auteurs puis imprimer la page
    for(i = 0; i < nbMedias; i++)
    {
        nbAuteurs = 0;
        tmpla = tabMedias[i]->auteurs;
        while(tmpla != NULL)
        {
            tmpla = tmpla->suiv;
            nbAuteurs++;
        }
        tabAuteurs = (ListeAuteurs**)malloc(nbAuteurs * sizeof(*tabAuteurs));
        tmpla = tabMedias[i]->auteurs;
        for(j = 0; j < nbAuteurs; j++)
        {
            tabAuteurs[j]=tmpla;
            tmpla = tmpla->suiv;
        }
        qsort(tabAuteurs, nbAuteurs, sizeof(tabAuteurs[0]), cmpAuteurs);
        //ici: on peut ecrire la page specifique et la ligne correspondante de la page principale
        printLigneIndex(tabMedias[i], i, tabAuteurs, nbAuteurs, index);
        printDetails(tabMedias[i], i, tabAuteurs, nbAuteurs, dir);
        free(tabAuteurs);
    }
    fprintf(index, "</table></body></html>");
    fclose(index);
    free(tabMedias);
}

int cmpMedias(const void* m1, const void* m2)
{
    return strcmp((*(media**)m1)->titre, (*(media**)m2)->titre);
}

int cmpAuteurs(const void* a1, const void* a2)
{//Ne trie pas encore selon les prenoms (lorsque c'est necessaire)
    int ret = strcmp((*(ListeAuteurs**)a1)->nom, (*(ListeAuteurs**)a2)->nom);
    return ret;
}

void printHead(char* title, FILE* f)
{
    fprintf(f, "<html><head><title>%s</title></head><body>", title);
}
void printLigneIndex(media* m, int nm, ListeAuteurs** la, int nba, FILE* f)
{
    int minTotales = 0, secTotales = 0;
    fprintf(f, "<tr>");
    fprintf(f, "<td><a href=\"media%d.html\">%s</a></td>", nm, m->titre);
    fprintf(f, "<td>");
    printAuteurs(la, nba, f);
    fprintf(f, "</td>");
    //Impression de l'editeur ou de la duree totale des plages
    fprintf(f, "<td>");
    if(m->type == DISQUE)
    {
        ListePlages* lptmp = m->plages;
        while(lptmp != NULL)
        {
            if(lptmp->minutes != -1)
            {
                minTotales += lptmp->minutes;
                secTotales += lptmp->secondes;
            }
            lptmp = lptmp->suiv;
        }
        if(secTotales >= 60)
            minTotales += (secTotales - (secTotales%60))/60;
            secTotales = secTotales%60;
        fprintf(f, "%d minutes %d secondes", minTotales, secTotales);
    }
    else if(m->type == LIVRE)
    {
        if(m->editeur != NULL)
            fprintf(f, "%s", m->editeur);
    }
    fprintf(f, "</td>");
    fprintf(f, "</tr>");
}

void printDetails(media* m, int nm, ListeAuteurs** la, int nba, char* dir)
{
    int i = 0;
    char* nomFichier = (char*)malloc((strlen(dir)+15)*sizeof(*nomFichier));
    sprintf(nomFichier, "%s/media%d.html", dir, nm);
    FILE* fm = fopen(nomFichier, "w");
    if(fm == NULL)
    {
        printf("erreur a l'ouverture du fichier media%d.html: verifiez que le repertoire %s existe et que vous y avez les permissions d'ecriture\n", nm, dir);
        exit(1);
    }
    printHead(m->titre, fm);

    fprintf(fm, "<table bgcolor=\"#EEFEFF\"><tr><td>");
    printAuteurs(la, nba, fm);
    fprintf(fm, "</td><td>%s<br/>", m->titre);
    if(m->annee != -1)
        fprintf(fm, "%d", m->annee);
    if(m->type == DISQUE)
    {
        fprintf(fm, "<br/>");//Imprimer les interpretes
        if(m->interpretes != NULL)
            printInterpretes(m->interpretes, fm);
        fprintf(fm, "</td>");
    }
    else if(m->type == LIVRE)
    {
        fprintf(fm, "<br/>");
        if(m->editeur != NULL)
            fprintf(fm, "%s<br/>", m->editeur);
        /*if(m->resume != NULL)
            fprintf(fm, "%s<br/>", m->resume);*/
        fprintf(fm, "</td>");
    }
    fprintf(fm, "</tr><tr>");
    if(m->photo != NULL)
    {
        fprintf(fm, "<td><img src=\"%s\"/></td>", m->photo);
    }
    if(m->type == DISQUE)
    {
        fprintf(fm, "<td>");
        i = 1;
        //Imprimer les plages avec leurs durees
        //Note: ils sont pour l'instant affiches dans l'ordre inverse de l'entree
        ListePlages* lptmp = m->plages;
        while(lptmp != NULL)
        {
            fprintf(fm, "%d - %s ", i, lptmp->titre);
            if(lptmp->minutes != -1)
            {
                fprintf(fm, "<font color=\"#888888\">[%d.", lptmp->minutes);
                if(lptmp->secondes < 10)
                    fprintf(fm, "0");
                fprintf(fm, "%d]</font>", lptmp->secondes);
            }
            fprintf(fm, "<br/>");
            lptmp = lptmp->suiv;
            i++;
        }
        fprintf(fm, "</td>");
    }
    else if(m->type == LIVRE)
    {
        fprintf(fm, "<td>");
        //Imprimer le resume, l'editeur
        if(m->resume != NULL)
            fprintf(fm, "%s", m->resume);
        fprintf(fm, "</td>");
    }
    fprintf(fm, "</tr>");
    if(m->notes != NULL)
        fprintf(fm, "<tr><td></td><td>%s</td></tr>", m->notes);

    fprintf(fm, "</table></body></html>");
    fclose(fm);
    free(nomFichier);
}

void printAuteurs(ListeAuteurs** la, int nba, FILE* f)
{
    int i = 0;
    printAuteur(la[0]->nom, la[0]->prenoms, la[0]->nbPrenoms, f);
    for(i = 1; i < nba; i++)
    {
        if(i == nba - 1)fprintf(f, " et ");
        else fprintf(f, ", ");
        printAuteur(la[i]->nom, la[i]->prenoms, la[i]->nbPrenoms, f);
    }
}

void printInterpretes(ListeInterpretes* la, FILE* f)
{
    printAuteur(la->nom, la->prenoms, la->nbPrenoms, f);
    if(la->qualite != NULL)
        fprintf(f, " (%s)", la->qualite);
    la = la->suiv;
    while(la != NULL)
    {
        if(la->suiv == NULL)fprintf(f, " et ");
        else fprintf(f, ", ");
        printAuteur(la->nom, la->prenoms, la->nbPrenoms, f);
        if(la->qualite != NULL)
            fprintf(f, " (%s)", la->qualite);
        la = la->suiv;
    }
}

void printAuteur(char* nom, char** prenoms, int nbPrenoms, FILE* f)
{
    //Impressions des prenoms abreges et du nom
    int i = 0, j = 0;
    for(j = 0; j < nbPrenoms; j++)
    {
        fprintf(f, "%c. ", prenoms[j][0]);
        for(i = 1; prenoms[j][i] != '\0'; i++)
        {//Methode un peu sauvage pour les noms composes
            if(prenoms[j][i-1] == '-')
                fprintf(f, "-%c. ", prenoms[j][i]);
        }
    }
    fprintf(f, "%s", nom);
}
