/*
 * Alexandre LHUILLIER
 * FIPA 2
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "medias.h"

media* initMedia()
{
    media* ret = (media*)malloc(sizeof(media));
    ret->auteurs = NULL;
    ret->interpretes  = NULL;
    ret->annee = -1;
    ret->photo = NULL;
    ret->resume = NULL;
    ret->plages = NULL;
    ret->notes = NULL;
    ret->editeur = NULL;
    return ret;
}

void libereListe(ListeMedias* liste)
{
    ListeMedias* listePrec = liste;
    ListeAuteurs* auteursPrec;
    ListeInterpretes* interpretesPrec;
    ListePlages* plagesPrec;
    int i;
    while(liste != NULL)
    {
        while(liste->m->auteurs != NULL)
        {
            auteursPrec = liste->m->auteurs;
            free(auteursPrec->nom);
            for(i = 0; i < auteursPrec->nbPrenoms; i++)
                free(auteursPrec->prenoms[i]);
            free(auteursPrec->prenoms);
            liste->m->auteurs = liste->m->auteurs->suiv;
            free(auteursPrec);
        }
        while(liste->m->interpretes != NULL)
        {
            interpretesPrec = liste->m->interpretes;
            free(interpretesPrec->nom);
            for(i = 0; i < interpretesPrec->nbPrenoms; i++)
                free(interpretesPrec->prenoms[i]);
            free(interpretesPrec->prenoms);
            liste->m->interpretes = liste->m->interpretes->suiv;
            free(interpretesPrec);
        }
        while(liste->m->plages != NULL)
        {
            plagesPrec = liste->m->plages;
            free(plagesPrec->titre);
            liste->m->plages = liste->m->plages->suiv;
            free(plagesPrec);
        }
        free(liste->m);
        listePrec = liste;
        liste = liste->suiv;
        free(listePrec);
    }
}

ListeMedias* addElement(ListeMedias* liste, media* m)
{
    if(liste == NULL)return creeListe(liste, m);
    ListeMedias* listePrec;
    listePrec = liste;
    while(liste->suiv != NULL)
    {
        liste = liste->suiv;
    }
    liste->suiv = (ListeMedias*)malloc(sizeof(ListeMedias));
    liste->suiv->m = m;
    liste->suiv->suiv = NULL;
    return listePrec;
}

ListeMedias* creeListe(ListeMedias* liste, media* m)
{
    liste = (ListeMedias*)malloc(sizeof(ListeMedias));
    liste->m = m;
    liste->suiv = NULL;
    return liste;
}

void printMedias(ListeMedias* lm)
{
    int i = 0;
    char* type[] = {"DISQUE", "LIVRE"};
    //methode brute pour imprimer les caracteristiques d'un media
    //pour le debug
    while(lm != NULL)
    {
        printf("%s\n", type[lm->m->type]);
        ListeAuteurs* latmp = lm->m->auteurs;
        while(latmp != NULL)
        {
            printf("Nom: %s Prenoms: ", latmp->nom);
            for(i = 0; i < latmp->nbPrenoms; i++)
                printf("%s ", latmp->prenoms[i]);
            printf("\n");
            latmp = latmp->suiv;
        }
        ListeInterpretes* litmp = lm->m->interpretes;
        while(litmp != NULL)
        {
            printf("Interprete: Nom: %s Prenoms: ", litmp->nom);
            for(i = 0; i < litmp->nbPrenoms; i++)
                printf("%s ", litmp->prenoms[i]);
            if(litmp->qualite != NULL)printf("Qualite: %s", litmp->qualite);
            printf("\n");
            litmp = litmp->suiv;
        }
        if(lm->m->annee != -1)
            printf("%d\n", lm->m->annee);
        if(lm->m->photo != NULL)
            printf("%s\n", lm->m->photo);
        printf("%s\n", lm->m->titre);
        if(lm->m->resume != NULL)
            printf("%s\n", lm->m->resume);
        ListePlages* lptmp = lm->m->plages;
        while(lptmp != NULL)
        {
            printf("Titre: %s Duree: %d:%d", lptmp->titre, lptmp->minutes, lptmp->secondes);
            printf("\n");
            lptmp = lptmp->suiv;
        }
        if(lm->m->notes != NULL)
            printf("%s\n", lm->m->notes);
        if(lm->m->editeur != NULL)
            printf("%s\n", lm->m->editeur);
        lm = lm->suiv;
    }
}

void addAuteur(char* nom, media* m)
{
    int i = 0;
    int j = 0;
    int nbMots = 0;
    char* nomcpy = strdup(nom);
    for(i = 0; nomcpy[i] != '\0'; i++)
    {
        if(nomcpy[i] == ' '){nomcpy[i] = '\0';nbMots++;}
    }
    ListeAuteurs* res = (ListeAuteurs*)malloc(sizeof(*res));
    res->nom = nomcpy;
    res->nbPrenoms = nbMots;
    res->prenoms = (char**)malloc(nbMots*sizeof(res->prenoms));
    res->suiv = NULL;
    for(i = 0, j=0; j < nbMots; i++)
    {
        if(res->nom[i] == '\0')
        {
            res->prenoms[j] = strdup(&(nomcpy[i+1]));i++;
            j++;
        }
    }
    if(m->auteurs == NULL)
        m->auteurs = res;
    else
    {
        ListeAuteurs* tmp = m->auteurs;
        m->auteurs = res;
        m->auteurs->suiv = tmp;
    }
}

void addInterprete(char* nom, char* qualite, media* m)
{
    int i = 0;
    int j = 0;
    int nbMots = 0;
    char* nomcpy = strdup(nom);
    for(i = 0; nomcpy[i] != '\0'; i++)
    {
        if(nomcpy[i] == ' '){nomcpy[i] = '\0';nbMots++;}
    }
    ListeInterpretes* res = (ListeInterpretes*)malloc(sizeof(*res));
    res->nom = nomcpy;
    res->nbPrenoms = nbMots;
    res->prenoms = (char**)malloc(nbMots*sizeof(char*));
    res->qualite = NULL;
    if(qualite != NULL)
        res->qualite = strdup(qualite);
    res->suiv = NULL;
    for(i = 0, j=0; j < nbMots; i++)
    {
        if(res->nom[i] == '\0')
        {
            res->prenoms[j] = strdup(&(nomcpy[i+1]));
            j++;
        }
    }
    if(m->interpretes == NULL)
        m->interpretes = res;
    else
    {
        ListeInterpretes* tmp = m->interpretes;
        m->interpretes = res;
        m->interpretes->suiv = tmp;
    }
}

void addPlage(char* titre, int minutes, int secondes, media* m)
{
    char* titrecpy = strdup(titre);
    ListePlages* res = (ListePlages*)malloc(sizeof(*res));
    res->titre = titrecpy;
    res->minutes = minutes;
    res->secondes = secondes;
    res->suiv = NULL;
    if(m->plages == NULL)
        m->plages = res;
    else
    {
        ListePlages* tmp = m->plages;
        m->plages = res;
        m->plages->suiv = tmp;
    }
}

