/*
 * Alexandre LHUILLIER
 * FIPA 2
*/

#ifndef MEDIAS
#define MEDIAS

/*
 * Structures stockant les donnees avant leur ecriture
 * dans les fichiers html
*/

enum TypeMedia{DISQUE, LIVRE}TypeMedia;

typedef struct ListeAuteurs
{
    struct ListeAuteurs* suiv;
    char* nom;
    char** prenoms;
    int nbPrenoms;
}ListeAuteurs;

typedef struct ListeInterpretes
{
    struct ListeInterpretes* suiv;
    char* nom;
    char** prenoms;
    int nbPrenoms;
    char* qualite;
}ListeInterpretes;

typedef struct ListePlages
{
    struct ListePlages* suiv;
    char* titre;
    int minutes;
    int secondes;
}ListePlages;

typedef struct media
{
    enum TypeMedia type;
    ListeAuteurs* auteurs;
    ListeInterpretes* interpretes;
    int annee;
    char* photo;
    char* titre;
    char* resume;
    ListePlages* plages;
    char* notes;
    char* editeur;
}media;

typedef struct ListeMedias
{
    struct ListeMedias* suiv;
    media* m;
}ListeMedias;

ListeMedias* lm;
media* mediaCourant;
int nbMedias;

void libereListe(ListeMedias* liste);
ListeMedias* addElement(ListeMedias* liste, media* m);
ListeMedias* creeListe(ListeMedias* liste, media* m);
void printMedias(ListeMedias* lm);//Methode utilisee pour le debug de cette API uniquement
media* initMedia();

void addAuteur(char* nom, media* m);
void addInterprete(char* nom, char* qualite, media* m);
void addPlage(char* titre, int minutes, int secondes, media* m);
#endif
