%{
/*
 * Alexandre LHUILLIER
 * FIPA 2
*/
    #include "parser.h"
    #include "htmlspitter.h"
    #include <string.h>
    #include <stdio.h>
    #include <stdlib.h>
    int yyparse();
    int yyerror();
    /*
     * Les 8 types et champs suivants ne sont
     * utilises que pour la gestion des erreurs
    */
    int cpt = 1;
    enum Champ
    {
        AUTEURS,
        INTERPRETES,
        ANNEE,
        PHOTO,
        TITRE,
        RESUME,
        PLAGE,
        DUREE,
        NOTES,
        EDITEUR
    }Champ;
    enum Champ chCourant;//champ courant
    enum Champ chPrec;//champ precedent
    typedef struct formeChamp
    {
        char* nom;
        int type;
    }formeChamp;
    formeChamp* formesChamps[10];
    char* types[6];
    int chAuteurs = 0, chTitre = 0;
#ifndef FLAGS
#define FLAGS
    int texteLibre = 0;//1 pour un texte, 2 pour une URL
    int dansChamp = 0;
#endif
%}
COMM_LIGNE \%\%.*
ENTIER [0-9]+
MOT [a-zA-Z\-]+
PONCTUATION [\-\'\?\,\.\;\:\!\/\=\_]+
%x IN_COMM
%%
<IN_COMM>[^*] {/*j'avoue: http://dinosaur.compilertools.net/flex/flex_11.html */}
<IN_COMM>\*[^)] {}
\(\* BEGIN IN_COMM;
<IN_COMM>\*\) BEGIN(0);
\\Auteurs	{chPrec = chCourant;chCourant = AUTEURS; dansChamp = 0;texteLibre = 0;chAuteurs++;return LIBELLE_AUTEUR;}
\\Titre		{chPrec = chCourant;chCourant = TITRE; dansChamp = 0;texteLibre = 1;chTitre++;return LIBELLE_TITRE;}
\\Resume	{chPrec = chCourant;chCourant = RESUME; dansChamp = 0;texteLibre = 1;return LIBELLE_RESUME;}
\\Editeur	{chPrec = chCourant;chCourant = EDITEUR; dansChamp = 0;texteLibre = 1;return LIBELLE_EDITEUR;}
\\Interpretes	{chPrec = chCourant;chCourant = INTERPRETES; dansChamp = 0;texteLibre = 0;return LIBELLE_INTERPRETE;}
\\Plage		{chPrec = chCourant;chCourant = PLAGE; dansChamp = 0;texteLibre = 1;return LIBELLE_PLAGE;}
\\Duree		{chPrec = chCourant;chCourant = DUREE; dansChamp = 0;texteLibre = 0;return LIBELLE_DUREE;}
\\Annee		{chPrec = chCourant;chCourant = ANNEE; dansChamp = 0;texteLibre = 0;return LIBELLE_ANNEE;}
\\Photo		{chPrec = chCourant;chCourant = PHOTO; dansChamp = 0;texteLibre = 2;return LIBELLE_PHOTO;}
\\Notes		{chPrec = chCourant;chCourant = NOTES; dansChamp = 0;texteLibre = 1;return LIBELLE_NOTES;}
({COMM_LIGNE}?\n)[ \t]*DISQUE[ \t]*({COMM_LIGNE}?\n)	{mediaCourant = initMedia();mediaCourant->type = DISQUE;cpt += 2;nbMedias++;chAuteurs = 0;chTitre = 0;return LIBELLE_DISQUE;}
({COMM_LIGNE}?\n)[ \t]*LIVRE[ \t]*({COMM_LIGNE}?\n)	{mediaCourant = initMedia();mediaCourant->type = LIVRE;cpt += 2;nbMedias++;chAuteurs = 0;chTitre = 0;return LIBELLE_LIVRE;}
{COMM_LIGNE}	{;}
\\\(		{if(texteLibre > 0 && dansChamp == 1){yylval.id = "("; return PONCTUATION;}}
\\\)		{if(texteLibre > 0 && dansChamp == 1){yylval.id = ")"; return PONCTUATION;}}
\(		{return OPEN_MEDIA;}
\)		{texteLibre = 0;return CLOSE_MEDIA;}
\=		{if(texteLibre > 0 && dansChamp == 1){yylval.id = strdup(yytext); return PONCTUATION;}else {dansChamp = 1;return AFFECT;}}
\;		{if(texteLibre > 0 && dansChamp == 1){yylval.id = strdup(yytext); return PONCTUATION;}else return POINTVIRGULE;}
\:		{if(texteLibre > 0 && dansChamp == 1){yylval.id = strdup(yytext); return PONCTUATION;}else return DEUXPOINTS;}
{ENTIER}	{if(texteLibre > 0 && dansChamp == 1){yylval.id = strdup(yytext); return MOT;}else{yylval.entier = atoi(yytext); return NOMBRE;}}
{MOT}		{yylval.id = strdup(yytext); return MOT;}
{PONCTUATION}	{yylval.id = strdup(yytext); return PONCTUATION;}
[ \t]+		{if(texteLibre == 1 && dansChamp == 1){yylval.id = strdup(yytext); return PONCTUATION;}}
\n		{cpt++;if(texteLibre == 1 && dansChamp == 1){yylval.id = strdup(yytext); return PONCTUATION;}}
\r		{;}
<<EOF>>		{return MYEOF;}
.		{if(texteLibre == 1 && dansChamp == 1){yylval.id = strdup(yytext); return PONCTUATION;}/*A virer eventuellement en cas de comportements indesirables*/}
%%
int yyerror()
{
    printf("erreur ligne %d: %s\n", cpt, yytext);
    if(mediaCourant->type == DISQUE)
    {
        if(strcmp(yytext, "\\Resume") == 0)
        {
            printf("Un champ \\Resume ne doit pas etre present dans un bloc DISQUE\n");
            exit(1);
        }
        else if(strcmp(yytext, "\\Editeur") == 0)
        {
            printf("Un champ \\Editeur ne doit pas etre present dans un bloc DISQUE\n");
            exit(1);
        }
        else if(strcmp(yytext, "\\Duree") == 0 && strcmp(formesChamps[chPrec]->nom, "\\Plage") != 0)
        {
            printf("Un champ \\Duree doit etre precede d'un champ \\Plage\n");
            exit(1);
        }
    }
    else if(mediaCourant->type == LIVRE)
    {
        if(strcmp(yytext, "\\Plage") == 0)
        {
            printf("Un champ \\Plage ne doit pas etre present dans un bloc LIVRE\n");
            exit(1);
        }
        else if(strcmp(yytext, "\\Duree") == 0)
        {
            printf("Un champ \\Duree ne doit pas etre present dans un bloc LIVRE\n");
            exit(1);
        }
        else if(strcmp(yytext, "\\Interpretes") == 0)
        {
            printf("Un champ \\Interpretes ne doit pas etre present dans un bloc LIVRE\n");
            exit(1);
        }
    }
    if(strcmp(yytext, "\\Auteurs") == 0 && chAuteurs>1)printf("Le champ obligatoire \\Auteurs est deja present plus haut dans ce media\n");
    else if(strcmp(yytext, "\\Titre") == 0 && chTitre>1)printf("Le champ obligatoire \\Titre est deja present plus haut dans ce media\n");
    else if(strcmp(yytext, formesChamps[chCourant]->nom) == 0)
    {
        printf("champ precedent mal forme\n");
        printf("format du champ %s: %s = %s\n", formesChamps[chPrec]->nom, formesChamps[chPrec]->nom, types[formesChamps[chPrec]->type]);
    }
    else if(yytext[0] == ')')
    {
        if(chAuteurs == 0)printf("Le champ obligatoire \\Auteurs est absent de ce media\n");
        if(chTitre == 0)printf("Le champ obligatoire \\Titre est absent de ce media\n");
    }
    exit(1);
}
/*
 * Les donnees initialisees ici permettent de montrer a l'utilisateur
 * comment bien former un champ lorsqu'un champ mal forme est lu
*/
void initFormesChamps()
{
    int i = 0;
    for(i = 0; i < 10; i++)
        formesChamps[i] = (formeChamp*)malloc(sizeof(*formesChamps[i]));
    formesChamps[0]->nom = strdup("\\Auteurs");
    formesChamps[0]->type = 0;
    formesChamps[1]->nom = strdup("\\Interpretes");
    formesChamps[1]->type = 1;
    formesChamps[2]->nom = strdup("\\Annee");
    formesChamps[2]->type = 2;
    formesChamps[3]->nom = strdup("\\Photo");
    formesChamps[3]->type = 3;
    formesChamps[4]->nom = strdup("\\Titre");
    formesChamps[4]->type = 4;
    formesChamps[5]->nom = strdup("\\Resume");
    formesChamps[5]->type = 4;
    formesChamps[6]->nom = strdup("\\Plage");
    formesChamps[6]->type = 4;
    formesChamps[7]->nom = strdup("\\Duree");
    formesChamps[7]->type = 5;
    formesChamps[8]->nom = strdup("\\Notes");
    formesChamps[8]->type = 4;
    formesChamps[9]->nom = strdup("\\Editeur");
    formesChamps[9]->type = 4;

    types[0] = strdup("<nom> <prenoms>; <nom> <prenoms>");
    types[1] = strdup("<nom> <prenoms>(qualite); <nom> <prenoms>(qualite)");
    types[2] = strdup("<nombre entier>");
    types[3] = strdup("<URL>");
    types[4] = strdup("<Texte libre>");
    types[5] = strdup("<nombre entier>:<nombre entier>");
}

void libereFormesChamps()
{
    int i = 0;
    for(i = 0; i < 10; i++)
    {
        free(formesChamps[i]->nom);
        free(formesChamps[i]);
    }
    for(i = 0; i < 6; i++)
        free(types[i]);
}

int main (int argc, char** argv)
{
    if(argc != 3)
    {
        printf("usage: %s <fichier> <repertoire_destination>\n", argv[0]);
        exit(1);
    }
    initFormesChamps();
    nbMedias = 0;
    yyin = fopen(argv[1], "r");
    if(yyin == NULL)
    {
        printf("Impossible d'ouvrir le fichier %s\n", argv[1]);
        exit(1);
    }
    int i = yyparse();
    fclose(yyin);
    cracherHTML(argv[2], lm, nbMedias);
    libereListe(lm);
    libereFormesChamps();
    return i;
}
