%{
/*
 * Alexandre LHUILLIER
 * FIPA 2
*/
    #include "parser.h"
    #include "medias.h"
    #include <stdio.h>
    #include <string.h>
    #include <stdlib.h>
    int yylex(void);
    int yyerror(char* s);
    int cpt;
    #ifndef FLAGS
    #define FLAGS
    int texteLibre;
    int dansChamp;
    #endif
%}
%union
{
    int entier;
    char nop;
    char* id;
}
%token <entier> NOMBRE
%token <id> MOT
%token <id> PONCTUATION
%token <id> URL
%token <nop> AFFECT
%token <nop> OPEN_MEDIA
%token <nop> CLOSE_MEDIA
%token <nop> POINTVIRGULE
%token <nop> DEUXPOINTS
%token <nop> MYEOF
%token <id> LIBELLE_ANNEE
%token <id> LIBELLE_PHOTO
%token <id> LIBELLE_NOTES
%token <id> LIBELLE_AUTEUR
%token <id> LIBELLE_TITRE
%token <id> LIBELLE_RESUME
%token <id> LIBELLE_EDITEUR
%token <id> LIBELLE_INTERPRETE
%token <id> LIBELLE_PLAGE
%token <id> LIBELLE_DUREE
%token <id> LIBELLE_DISQUE
%token <id> LIBELLE_LIVRE


%type <nop> debut
%type <nop> medias
%type <id> suite_mots
%type <id> suite_mots_libres
%type <nop> champs_disque
%type <nop> champs_livre

%start debut
%%

debut
:medias MYEOF {return 0;}
;

medias
: medias OPEN_MEDIA LIBELLE_DISQUE champs_disque CLOSE_MEDIA
{lm = addElement(lm, mediaCourant);}
| medias OPEN_MEDIA LIBELLE_LIVRE champs_livre CLOSE_MEDIA
{lm = addElement(lm, mediaCourant);}
| OPEN_MEDIA LIBELLE_DISQUE champs_disque CLOSE_MEDIA
{lm = addElement(lm, mediaCourant);}
| OPEN_MEDIA LIBELLE_LIVRE champs_livre CLOSE_MEDIA
{lm = addElement(lm, mediaCourant);}
;
champs_disque
: auteur titre {}
| titre auteur {}
| auteur titre champs_opt_disque {}
| titre auteur champs_opt_disque {}
| champs_opt_disque auteur titre {}
| champs_opt_disque titre auteur {}
| auteur champs_opt_disque titre {}
| titre champs_opt_disque auteur {}
| auteur champs_opt_disque titre champs_opt_disque {}
| titre champs_opt_disque auteur champs_opt_disque {}
| champs_opt_disque auteur titre champs_opt_disque {}
| champs_opt_disque titre auteur champs_opt_disque {}
| champs_opt_disque auteur champs_opt_disque titre {}
| champs_opt_disque titre champs_opt_disque auteur {}
| champs_opt_disque auteur champs_opt_disque titre champs_opt_disque
{}
| champs_opt_disque titre champs_opt_disque auteur champs_opt_disque
{}
;
champs_livre
: auteur titre {}
| titre auteur {}
| auteur titre champs_opt_livre {}
| titre auteur champs_opt_livre {}
| champs_opt_livre auteur titre {}
| champs_opt_livre titre auteur {}
| auteur champs_opt_livre titre {}
| titre champs_opt_livre auteur {}
| auteur champs_opt_livre titre champs_opt_livre {}
| titre champs_opt_livre auteur champs_opt_livre {}
| champs_opt_livre auteur titre champs_opt_livre {}
| champs_opt_livre titre auteur champs_opt_livre {}
| champs_opt_livre auteur champs_opt_livre titre {}
| champs_opt_livre titre champs_opt_livre auteur {}
| champs_opt_livre auteur champs_opt_livre titre champs_opt_livre
{}
| champs_opt_livre titre champs_opt_livre auteur champs_opt_livre
{}
;
champ_opt
: annee
| photo
| notes
;
champs_opt_disque
: champs_opt_disque champ_opt_disque
| champ_opt_disque
;
champs_opt_livre
: champs_opt_livre champ_opt_livre
| champ_opt_livre
;
champ_opt_disque
: champ_opt
| interprete
| plage_duree
;
champ_opt_livre
: champ_opt
| resume
| editeur
;
auteur
: LIBELLE_AUTEUR AFFECT suite_noms {/*traite dans suite_noms*/}
;
titre
: LIBELLE_TITRE AFFECT suite_mots_libres {mediaCourant->titre = strdup($3);}
;
resume
: LIBELLE_RESUME AFFECT suite_mots_libres {mediaCourant->resume = strdup($3);}
;
editeur
: LIBELLE_EDITEUR AFFECT suite_mots_libres {mediaCourant->editeur = strdup($3);}
;
interprete
: LIBELLE_INTERPRETE AFFECT suite_interpretes {/*traite dans suite_interpretes*/}
;
plage_duree
: LIBELLE_PLAGE AFFECT suite_mots_libres LIBELLE_DUREE AFFECT NOMBRE DEUXPOINTS NOMBRE {addPlage($3, $6, $8, mediaCourant);texteLibre = 0;}
| LIBELLE_PLAGE AFFECT suite_mots_libres {addPlage($3, -1, -1, mediaCourant);}
;
annee
: LIBELLE_ANNEE AFFECT NOMBRE {mediaCourant->annee = $3;}
;
photo
: LIBELLE_PHOTO AFFECT suite_mots_libres {mediaCourant->photo = strdup($3);}
;
notes
: LIBELLE_NOTES AFFECT suite_mots_libres {mediaCourant->notes = strdup($3);}
;
suite_mots
: suite_mots MOT {char* esp = (char*)malloc(sizeof(char)*2);esp[0] = ' ';esp[1]='\0';$$ = strcat($$, esp);$$ = strcat($$, $2);}
| MOT {$$ = strdup($1);}
;
/*Note:
 *Eviter les parentheses dans les suites de mots libres pour le moment
*/
suite_mots_libres
: suite_mots_libres MOT {$$ = strcat($$, $2);}
| suite_mots_libres PONCTUATION {$$ = strcat($$, $2);}
| MOT {$$ = strdup($1);}
| PONCTUATION {$$ = strdup($1);}
;
suite_noms
: suite_noms POINTVIRGULE suite_mots {addAuteur($3, mediaCourant);}
| suite_mots {addAuteur($1, mediaCourant);}
;
suite_interpretes
: suite_interpretes POINTVIRGULE suite_mots OPEN_MEDIA suite_mots CLOSE_MEDIA {addInterprete($3, $5, mediaCourant);}
| suite_interpretes POINTVIRGULE suite_mots {addInterprete($3, NULL, mediaCourant);}
| suite_mots OPEN_MEDIA suite_mots CLOSE_MEDIA {addInterprete($1, $3, mediaCourant);}
| suite_mots {addInterprete($1, NULL, mediaCourant);}
;
%%
